#ifndef BPROTEST_INCLUDED
#define BPROTEST_INCLUDED

#import <database>
#import <maximize>

enum
{   Y_VAR, X_VAR
};

/*-------------------------- Probit : Database -----------------------------*/
class Probit : Database
{
    decl m_iModel;                  /* TRUE if model successfully estimated */
    decl m_fPrint;               /* TRUE if output desired after estimation */
    decl m_iResult;                             /* return code from MaxBFGS */
    decl m_iT1est, m_iT2est;                           /* estimation sample */
    decl m_cT;                                    /* number of observations */
    decl m_cY;             /* number of dependent variables (always 1 here) */
    decl m_cX;                             /* number of regressors (if any) */

    decl m_mY;                                /* dependent variable [cT][1] */
    decl m_mX;                          /* regressor data vector [cT][m_cX] */
    decl m_mPar;                                      /* parameters: [p][1] */
    decl m_dLoglik;                                       /* log-likelihood */

    Probit();                                                /* constructor */
    InitData();                               /* extract data from database */
    Estimate(const vStart);                            /* do the estimation */
    Output();                                          /* print the results */
    SetPrint(const fPrint);/* sets m_fPrint to control generation of output */
    IsConverged();
    GetParameters();
    GetStandardErrors();

    fProbit(const vP, const adFunc, const avScore, const amHessian);  /* LL */
};
/*------------------------ END Probit : Database ---------------------------*/

#endif	// BPROTEST_INCLUDED
